--
-- teleskopAxle
-- Specialization for teleskopAxle
--
-- monteur1

teleskopAxle = {};

function teleskopAxle.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(AnimatedVehicle, specializations);
end

function teleskopAxle:getSaveAttributesAndNodes(nodeIdent)
	local attributes = 'teleskopAxleState="'..tostring(Utils.getNoNil(self.teleskopAxleState))
	attributes = attributes ..'"';
	return attributes
end;

function teleskopAxle:load(xmlFile)
    self.teleskopAxleAnimation = getXMLString(self.xmlFile, "vehicle.teleskopAxle#animationName");	
    self.teleskopAxleVisibleNode = Utils.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.teleskopAxle#visiblenode"));	
	self.teleskopAxleVisible = false
	self.teleskopAxleState = 1
end

function teleskopAxle:postLoad(savegame)
    if savegame ~= nil and not savegame.resetVehicles then
		local saveStateteleskopAxle = Utils.getNoNil(getXMLFloat(savegame.xmlFile, savegame.key.."#teleskopAxleState"));
		if saveStateteleskopAxle == 1 then
			self:playAnimation(self.teleskopAxleAnimation, 10000, nil, true);--Teleskopachse einfahren
			self.teleskopAxleState = 1
		elseif saveStateteleskopAxle == 2 then
			self:playAnimation(self.teleskopAxleAnimation, -10000, nil, true);--Teleskopachse ausfahren
			self.teleskopAxleState = 2
		end
	else
		self:playAnimation(self.teleskopAxleAnimation, 10000, nil, true);--Teleskopachse einfahren
		self.teleskopAxleState = 1
	end
end;

function teleskopAxle:readStream(streamId, connection)
	self.teleskopAxleState = streamReadFloat32(streamId);
	self.teleskopAxleVisible = streamReadBool(streamId);
end

function teleskopAxle:writeStream(streamId, connection)
	streamWriteFloat32(streamId, self.teleskopAxleState);
	streamWriteBool(streamId, self.teleskopAxleVisible);
end

function teleskopAxle:update(dt)
	if self.isClient then
		if self:getIsActive() and self:getIsActiveForInput(true) then
			if self.teleskopAxleAnimation ~= nil then
				local AxleVisible = false
				if self.teleskopAxleAnimation ~= nil then
					AxleVisible = getVisibility(self.teleskopAxleVisibleNode)
					self.teleskopAxleVisible = AxleVisible
				end
				if self.teleskopAxleVisible == true then
					if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA2) then	
						if self.teleskopAxleState == 1 then
							self:playAnimation(self.teleskopAxleAnimation, -1, nil, true);--Teleskopachse ausfahren
							self.teleskopAxleState = 2
						elseif self.teleskopAxleState == 2 then
							self:playAnimation(self.teleskopAxleAnimation, 1, nil, true);--Teleskopachse einfahren
							self.teleskopAxleState = 1
						end
					end
				end
			end
		end
	end
end

function teleskopAxle:draw()
    if self:getIsActive() then
		if self.teleskopAxleVisible == true then
			 g_currentMission:addHelpButtonText(string.format(g_i18n:getText("move_TeleskopAxle")), InputBinding.IMPLEMENT_EXTRA2, nil, GS_PRIO_HIGH)		
		end
	end
end

function teleskopAxle:delete()
end;

function teleskopAxle:mouseEvent(posX, posY, isDown, isUp, button)
end;

function teleskopAxle:keyEvent(unicode, sym, modifier, isDown)
end;

function teleskopAxle:onAttach()
end; 	

function teleskopAxle:onDetach()
end;